#include <stdio.h>

#define TRUE 1
#define FALSE 0
/* This is not a perfect, torture testing random proposition generator.  It is
   meant to provide a quick and dirty sampling of propositional formulas. */

extern long total /* variables */, /* number of variables */ used, /*
	percentage chance of a proposition being negated */ negation, /*
	number of times variables are to be */ reused;

long total /* variables */, /* number of variables */ used, /* percentage
	chance of a proposition being negated */ negation, /*
	number of times variables are to be */ reused;

void generate(long new_use, long reuse); /* desired number of new variables in
					    formula, desired number of reused
					    variables */

void generate(long new_use, long reuse)
	{
	long left_new, left_re, right_new, right_re, cont;
	if (random()%100 < negation)
		{
		printf("(!\n");
		generate(new_use, reuse);
		printf(")\n");
		}
	else
		{
		if ((new_use + reuse) <= 1)
			{
			if (new_use >= 1)
				{
				++used;
				printf("%d\n", used);
				}
			else if (reuse >= 1)
				printf("%d\n", (random() % total) + 1);
			}
		else
			{
			for(cont=TRUE; (cont==TRUE);)
				{
				left_new = (random() % (new_use + 1));
				right_new = new_use - left_new;
				left_re = (random() % (reuse + 1));
				right_re = reuse - left_re;
				if (!(((left_new==0) && (left_re == 0)) ||
					((right_new==0) && (right_re == 0))))
					cont=FALSE;
				}
			printf("(\n");
			generate(left_new, left_re);
			printf("^\n");
			generate(right_new, right_re);
			printf(")\n");
			}
		}
	}

main()
	{
	long seed;
	/* We don't prompt for input, because the binary is meant to be run
	   with a shell script interfacing for it.  We prompt for the random
	   number seed, instead of using the time of day, because it may be
	   useful to record a seed along with other input, and thereby have a
	   shorthand way of regenerating a long formula.  */
	total=0;
	scanf("%d", &total);
	scanf("%d", &negation);
	scanf("%d", &reused);
	scanf("%d", &seed);
	srandom(seed);
	used=0;
	generate(total, reused);
	}
